/*
	Sistemi di Elaborazione I modulo
	Ingegneria delle Telecomunicazioni
	Appello del 22/7/2002
	Anno Accademico 2001/2002
	Compito A
*/

/*	Libreria di I/O	*/
#include <stdio.h>

/*	Libreria di gestione delle stringhe	*/
#include <string.h>

/*	Lunghezza codice identificativo valuta	*/
#define SIZE 3

/*	Nome del file contenente i dati di prova	*/
const char *fileName = "test_a.txt";

/*	Soluzione primo esercizio	*/
void quotMaxMin() {
	FILE* filePtr = NULL;

	/*	Apertura del file in modalit lettura	*/
	filePtr = fopen(fileName, "r");
	/*	Verifica corretta apertura 	*/
	if(filePtr != NULL) {
		char valutaSel[SIZE + 1];	/*	Valuta selezionata dall'utente	*/
		int numQuot = 0;		/*	Numero quotazioni lette		*/
		int giornoQuotMin;		/*	Giorno quotazione minima	*/
		int giornoQuotMax;		/*	Giorno quotazione massima	*/
		float quotMin;			/*	Quotazione minima		*/
		float quotMax;			/*	Quotazione massima		*/

		/*	Richiesta del codice della valuta	*/
		printf("Codice valuta : ");
		scanf("%s", valutaSel);
		/*	Si suppone che il codice sia corretto	*/

		/* 	Finch il file non  finito	*/
		while(!feof(filePtr)) {
			int res;		/*	Numero dei campi letti	*/
			int giorno;             /*	Giorno della quotazione	*/
			float quotazione;	/*	Valore della quotazione	*/
			char valuta[SIZE + 1];	/*	Valuta della quotazione	*/

			/*	Lettura di un record dal file	*/
			res = fscanf(filePtr, "%d %s %f", &giorno, valuta, &quotazione);
			/*	Se il numero dei campi letti  quello atteso (3) */
			if(3 == res) {
				/*	Se la valuta cui si riferisce il record letto
					 quella indicata dall'utente			*/
				if(strcmp(valuta, valutaSel) == 0) {
					/*	Incremento del numero di quotazioni	*/
					numQuot++;
					/*	Se si tratta della prima quotazione	*/
					if(1 == numQuot) {
						/* 	I valori letti sono il minimo e
							il massimo correnti		*/
						quotMin = quotMax = quotazione;
						giornoQuotMin = giornoQuotMax = giorno;
					} else {
						/*	Se la quotazione  maggiore del
							massimo corrente		*/
						if(quotazione > quotMax) {
							/*	Aggiornamento massimo	*/
							quotMax = quotazione;
							/*	e data relativa		*/
							giornoQuotMax = giorno;
						}
						/*	Se la quotazione  minore del
							minimo corrente			*/
						if(quotazione < quotMin) {
							/*	Aggiornamento	minimo	*/
							quotMin = quotazione;
							/*       e data relativa	*/
							giornoQuotMin = giorno;
						}
					}
				}
			} else {
				/*	Se il record letto non  valido
					si stampa un messaggio diagnostico
					e si prosegue con la lettura del file	*/
				printf("Record non valido!\n");
			}
		}
		/*	Se  stata letta almeno una quotazione relativa alla
			valuta indicata dall'utente si stampano i risultati	*/
		if(numQuot > 0) {
			printf("La quotazione minima  %f ed  stata registrata il giorno %d.\n", quotMin, giornoQuotMin);
			printf("La quotazione massima  %f ed  stata registrata il giorno %d.\n", quotMax, giornoQuotMax);
		} else {
			/*	Altrimenti si comunica che non sono presenti
				quotazioni relative alla valuta specificata	*/
			printf("Non  stata trovata nessuna quotazione della valuta specificata!\n");
		}
		/*	Chiusura del file 	*/
		fclose(filePtr);
	} else {
		/*	Messaggio diagnostico per segnalare errori in fase
			di apertura del file					*/
		printf("Impossibile aprire il file!\n");
	}
}

/*	Soluzione secondo esercizio	*/
void varPercQuot() {
	FILE* filePtr = NULL;

	/*	Apertura del file in modalit lettura	*/
	filePtr = fopen(fileName, "r");
	/*	Verifica corretta apertura 	*/
	if(filePtr != NULL) {
		char valutaSel[SIZE + 1];	/*	Valuta selezionata dall'utente	*/
		int numQuot = 0;		/*	Numero quotazioni lette		*/
		int giornoQuotPrec;		/*	Giorno quotazione precedente	*/
		float quotPrec;			/*	Valore quotazione precedente	*/

		/*	Richiesta del codice della valuta	*/
		printf("Codice valuta : ");
		scanf("%s", valutaSel);
		/*	Si suppone che il codice sia corretto	*/

		/* 	Finch il file non  finito	*/
		while(!feof(filePtr)) {
			int res;		/*	Numero dei campi letti	*/
			int giorno;		/*	Giorno della quotazione	*/
			float quotazione;	/*	Valore della quotazione	*/
			char valuta[SIZE + 1];	/*	Valuta della quotazione	*/

			/*	Lettura di un record dal file	*/
			res = fscanf(filePtr, "%d %s %f", &giorno, valuta, &quotazione);
			/*	Se il numero dei campi letti  quello atteso (3) */
			if(3 == res) {
				/*	Se la valuta cui si riferisce il record letto
					 quella indicata dall'utente			*/
				if(strcmp(valuta, valutaSel) == 0) {
					/*	Incremento del numero di quotazioni	*/
					numQuot++;
					/*	Se non si tratta della prima quotazione	*/
					if(numQuot > 1) {
						/*	Calcolo della variazione percentuale	*/
						float deltaPerc = (quotazione - quotPrec) / quotPrec;
						/*	Stampa del valore	*/
						printf("La variazione dal giorno %d al giorno %d  del %.2f%%\n", giornoQuotPrec, giorno, deltaPerc * 100);
					}
					/*	I valori correnti sono i nuovi valori "precendenti"	*/
					quotPrec = quotazione;
					giornoQuotPrec = giorno;
				}
			} else {
				/*	Se il record letto non  valido
					si stampa un messaggio diagnostico
					e si prosegue con la lettura del file	*/
				printf("Record non valido!\n");
			}
		}
		/*	Se non sono state lette quotazioni della valuta specificata
			si stampa un messaggio diagnostico				*/
		if(0 == numQuot) {
			printf("Non  stata trovata nessuna quotazione!\n");
		}
		/*	Chiusura del file 	*/
		fclose(filePtr);
	} else {
		/*	Messaggio diagnostico per segnalare errori in fase
			di apertura del file					*/
		printf("Impossibile aprire il file!\n");
	}
}

void main() {
	char scelta;
	do {
		printf("\n\nGestione quotazione valutarie\n");
		printf("\n-1- Stampare quotazione massima e minima\n");
		printf("-2- Stampare variazioni percentuali\n");
		printf("-0- Terminare il programma\n");
		printf("\nSelezionare l'operazione desiderata : ");
		fflush(stdin);
		scanf("%c", &scelta);
		switch(scelta) {
			case '1':
				quotMaxMin();
				break;
			case '2':
				varPercQuot();
				break;
		}
	} while(scelta != '0');
}
