/*
	Corso di Laurea di Ingegneria delle Telecomunicazioni
	Corso di Sistemi di Elaborazione - Primo Modulo
	Anno Accademico 2001/2002 - 4 Appello
*/

/*	Funzioni di I/O					*/
#include <stdio.h>
/*	Funzioni di manipolazione delle stringhe	*/
#include <string.h>

/*	Lunghezza codice volo		*/
#define SIZE_COD_VOLO 5
/*	Lunghezza codice aeroporto 	*/
#define SIZE_COD_AER 3
/*	Numero di minuti per giorno 	*/
const int MIN_PER_GIORNO = 60 * 14;
/*	Nome del file 			*/
const char *NOME_FILE = "orario.txt";

/*	Soluzione primo punto		*/
void f1()
{
	/*	File					*/
	FILE *filePtr = NULL;
	/*	Codice del volo				*/
	char codVolo[SIZE_COD_VOLO + 1];
	/*	Codice del volo selezionato dall'utente	*/
	char codVoloSel[SIZE_COD_VOLO + 1];
	/*	Codice dell'aeroporto di partenza	*/
	char codAerPart[SIZE_COD_AER + 1];
	/*	Codice dell'aeroporto di arrivo		*/
	char codAerArr[SIZE_COD_AER + 1];
	/*	Orario di partenza (ore e minuti)	*/
	int oraPart, minPart;
	/*	Orario di arrivo (ore e minuti)		*/
	int oraArr, minArr;
	/*	Tempo di percorrenza (in minuti)	*/
	int tempoPerc;
	/*	Risultato operazione di lettura		*/
	int res;
	/*      Il volo selezionato  stato trovato?	*/
	int trovato = 0;
	/*	Si  verificato un errore?		*/
	int errore = 0;

	/*	Apertura file in modalit di lettura	*/
	filePtr = fopen(NOME_FILE, "r");
	/*	Se il file non  stato aperto correttamente	*/
	if(NULL == filePtr)
	{
		/*	Stampa messaggio diagnostico	*/
		printf("Impossibile aprire il file %s!\n", NOME_FILE);
	}
	else    /* Altrimenti	*/
	{
		/*	Richiesta del codice del volo da cercare	*/
		printf("Inserire codice volo : ");
		scanf("%s", codVoloSel);
		/*	Finch il file non  terminato, il codice non
			 stato trovato e non si  verificato un errore	*/
		while(!feof(filePtr) && !trovato && !errore)
		{
			/*	Lettura di un record	*/
			res = fscanf(filePtr, "%s %s %s %d %d %d %d", codVolo, 
				codAerPart, codAerArr, &oraPart, &minPart, 
				&oraArr, &minArr);
			/*	Se il record  stato letto correttamente	*/
			if(7 == res)
			{
				/*	Se il codice del volo  uguale a
					quello specificato		*/
				if(0 == strcmp(codVolo, codVoloSel))
				{
					/*	Calcolo del tempo di
						percorrenza		*/
					tempoPerc = ((oraArr * 60) + minArr - ((oraPart * 60) + minPart));
					/*	Se il tempo di percorrenza
						 negativo		*/
					if(tempoPerc < 0)
					{
						/*	Allora il volo
							parte il giorno
							precedente	*/
						tempoPerc += MIN_PER_GIORNO;
					}
					/*	Stampa delle informazioni
						sul volo		*/
					printf("Il volo %s parte da %s alle ore %d:%d ed arriva a %s alle ore %d:%d impiegando %d minuti.\n", codVolo, codAerPart, oraPart, minPart, codAerArr, oraArr, minArr, tempoPerc);
					/*	Il codice specificato 
						stato trovato		*/
					trovato = 1;
				}
			}
			else	/* 	Altrimenti (il record  errato)	*/
			{
				/*	Stampa messaggio diagnostico	*/
				printf("Il file contiene un record non valido, impossibile proseguire!\n");
				/*	Si  verificato un errore	*/
				errore = 1;
			}
		}
		/*	Se  il codice specificato non  stato trovato	*/
		if(!trovato)
		{
			/*	Stampa messaggio informativo	*/
			printf("Il codice %s non compare in archivio!\n", codVoloSel);
		}
		/*	Chisura del file	*/
		fclose(filePtr);
	}
}

/*	Soluzione secondo punto		*/
void f2()
{
	/*	File						*/
	FILE *filePtr = NULL;
	/*	Codice del volo					*/
	char codVolo[SIZE_COD_VOLO + 1];
	/*	Codice dell'aeroporto selezionato dall'utente	*/
	char codAerSel[SIZE_COD_AER + 1];
	/*	Codice dell'aeroporto di partenza		*/
	char codAerPart[SIZE_COD_AER + 1];
	/*	Codice dell'aeroporto di arrivo			*/
	char codAerArr[SIZE_COD_AER + 1];
	/*	Risultato operazione di lettura			*/
	int res;
	/*      Il volo selezionato  stato trovato?		*/
	int trovato = 0;
	/*	Si  verificato un errore?			*/
	int errore = 0;

	/*	Apertura file in modalit di lettura	*/
	filePtr = fopen(NOME_FILE, "r");
	/*	Se il file non  stato aperto correttamente	*/
	if(NULL == filePtr)
	{
		/*	Stampa messaggio diagnostico	*/
		printf("Impossibile aprire il file %s!\n", NOME_FILE);
	}
	else	/*	Altrimenti	*/
	{
		/*	Richiesta del codice dell'aeroporto da cercare	*/
		printf("Inserire codice aeroporto : ");
		scanf("%s", codAerSel);
		printf("I voli in partenza da %s sono :\n", codAerSel);
		/*	Finch il file non  terminato e non si  verificato 
			un errore	*/
		while(!feof(filePtr) && !errore)
		{
			/*	Lettura di un record	*/
			res = fscanf(filePtr, "%s %s %s %*d %*d %*d %*d", 
				codVolo, codAerPart, codAerArr);
			/*	Se il record  stato letto correttamente	*/
			if(3 == res)
			{
				/*	Se il codice dell'aeroporto di
					partenza  uguale a quello 
					specificato		*/
				if(0 == strcmp(codAerPart, codAerSel))
				{
					/*	Stampa delle informazioni
						sul volo		*/
					printf("Volo %s diretto a %s\n", codVolo, codAerArr);
					trovato = 1;
				}
			}
			else	/* 	Altrimenti (il record  errato)	*/
			{
				/*	Stampa messaggio diagnostico	*/
				printf("Il file contiene un record non valido, impossibile proseguire!\n");
				/*	Si  verificato un errore	*/
				errore = 1;
			}
		}
		/*	Se  il codice specificato non  stato trovato	*/
		if(!trovato)
		{
			/*	Stampa messaggio informativo	*/
			printf("Nessuno, controllare il codice aeroporto %s!\n", codAerSel);
		}
		/*	Chisura del file	*/
		fclose(filePtr);
	}
}

void main()
{
	char scelta;
	int uscita = 0;
	do
	{
		printf("\n1)\tStampa informazioni volo\n");
		printf("2)\tStampa voli in partenza\n");
		printf("\n0)\tUscita\n");
		printf("\nScelta : ");
		fflush(stdin);
		scanf("%c", &scelta);
		switch(scelta)
		{
			case '1' :
				f1();
				break;
			case '2' :
				f2();
				break;
			case '0' :
				uscita = 1;
				break;
			default :
				printf("Scelta errata!\n");
		}
	}
	while(!uscita);
}

